.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
ToolboxThreadProc   PROTO   :DWORD


include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350
BS_STYLE            equ     WS_VISIBLE+WS_CHILD+BS_PUSHBUTTON
NoButtons           equ     8
BaseResource        equ     100
.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      '???',0

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>

ReBarClass  db      'ReBarWindow32',0
hReBar      dd      ?

ToolboxThreadID     dd      ?
hToolboxThread      dd      ?
rbbi        REBARBANDINFO       <>
ButtonClass db      'BUTTON',0
hButton     dd      ?
rect        RECT        <>

TBButtons   TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
            TBBUTTON    <1,1,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
            TBBUTTON    <2,2,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
            TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
            TBBUTTON    <3,3,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
            TBBUTTON    <4,4,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
            TBBUTTON    <5,5,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
            TBBUTTON    <6,6,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
            
hToolbar    dd      ?
ToolbarClass    db      'ToolbarWindow32',0
hBmp        dd      ?
hMask       dd      ?
hList       dd      ?

.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    local   iccx:INITCOMMONCONTROLSEX
    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
    .elseif uMsg==WM_CREATE
        mov edi,lParam
        .if [edi.CREATESTRUCT].hWndParent==NULL
            mov     iccx.dwSize,sizeof iccx
            mov     iccx.dwICC,ICC_COOL_CLASSES+ICC_BAR_CLASSES
            invoke  InitCommonControlsEx,ADDR iccx
            invoke  GetClientRect,hWnd,addr rect
            invoke  CreateThread,NULL,NULL,addr ToolboxThreadProc,NULL,NULL,ToolboxThreadID
            mov     hToolboxThread,eax
            invoke  CreateWindowEx,WS_EX_TOOLWINDOW,addr ReBarClass,NULL,WS_VISIBLE+WS_CHILD\
                        +RBS_AUTOSIZE+CCS_NODIVIDER+WS_CLIPSIBLINGS+WS_CLIPCHILDREN,\
                        0,0,32,rect.right,hWnd,010h,hInstance,NULL
            mov     hReBar,eax
        .endif            
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

.data
wc2     WNDCLASSEX  <sizeof wc2,CS_HREDRAW+CS_VREDRAW,offset ToolboxWndProc,\
                    0,0,0,0,0,COLOR_WINDOW,0,offset ToolboxClass,0>
hToolbox    dd      ?
ToolboxName db      'Toolbox',0
ToolboxClass    db      'ToolboxClass',0
pt      POINT       <0,0>

.code

ToolboxThreadProc   PROC    Arg:DWORD

    local   msg:MSG

    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc2.hCursor,eax
    push    hInstance
    pop     wc2.hInstance
    invoke  RegisterClassEx,addr wc2
    invoke  CreateWindowEx,WS_EX_TOOLWINDOW,addr ToolboxClass,addr ToolboxName,WS_CLIPCHILDREN+WS_CLIPSIBLINGS,\
                CW_USEDEFAULT,CW_USEDEFAULT,231,56,NULL,NULL,hInstance,NULL
    mov     hToolbox,eax
    invoke  ShowWindow,eax,SW_SHOWNORMAL
    invoke  UpdateWindow,hToolbox

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_loop:
    mov     eax,msg.wParam
    ret

ToolboxThreadProc   endp

ToolboxWndProc  PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

        local   ri:REBARINFO
    
    .if uMsg==WM_DESTROY
        invoke  ExitThread,hToolboxThread
    .elseif uMsg==WM_CREATE
        mov edi,lParam
        .if [edi.CREATESTRUCT].hWndParent==NULL
            invoke  CreateWindowEx,NULL,addr ToolbarClass,NULL,WS_VISIBLE+WS_CHILD+TBSTYLE_ALTDRAG,\
                        0,0,CW_USEDEFAULT,CW_USEDEFAULT,hWnd,NULL,hInstance,NULL
            mov     hToolbar,eax
            invoke  ImageList_Create,24,24,ILC_COLOR32+ILC_MASK,8,8
            mov     hList,eax
            invoke  SendMessage,hToolbar,TB_SETIMAGELIST,NULL,eax
            mov     edi,BaseResource
            mov     ecx,NoButtons-1
img_loop:   
            push    ecx
            invoke  LoadBitmap,hInstance,edi
            mov     hBmp,eax
            inc     edi
            invoke  LoadBitmap,hInstance,edi
            mov     hMask,eax
            inc     edi
            invoke  ImageList_Add,hList,hBmp,hMask
            invoke  DeleteObject,hBmp
            invoke  DeleteObject,hMask
            pop     ecx
            dec     ecx
            jcxz    end_img
            jmp     img_loop
end_img:            
            invoke  SendMessage,hToolbar,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,NULL
            invoke  SendMessage,hToolbar,TB_ADDBUTTONS,NoButtons,addr TBButtons
            invoke  SendMessage,hToolbar,TB_AUTOSIZE,NULL,NULL  
        .endif            
    .elseif uMsg==WM_MOVE
            invoke  GetClientRect,hMainWindow,addr rect
            push    rect.top
            pop     pt.y
            push    rect.left
            pop     pt.x
            invoke  ClientToScreen,hMainWindow,addr pt
            mov     eax,lParam
            shr     eax,16
            .if     eax>pt.y
                sub     eax,pt.y
                .if     eax<=5
                    jmp attach
                .endif
            .elseif     eax<pt.y
                sub     pt.y,eax
                .if     pt.y<=5
                    jmp attach
                .endif
            .endif
            jmp     ender                
attach:                     
                        mov     ri.cbSize,sizeof ri
                        mov     ri.fMask,RBIM_IMAGELIST
                        push    hList
                        pop     ri.himl
                        invoke  SendMessage,hReBar,RB_SETBARINFO,NULL,addr ri                                                                                                     
                        mov     rbbi.cbSize,sizeof rbbi
                        mov     rbbi.fMask,RBBIM_CHILD+RBBIM_SIZE+RBBIM_STYLE+RBBIM_CHILDSIZE
                        push    hWnd
                        pop     rbbi.hwndChild
                        mov     rbbi.lx,231
                        mov     rbbi.cxMinChild,231
                        mov     rbbi.cyMinChild,28
                        mov     rbbi.cyChild,28
                        mov     rbbi.cyIntegral,300
                        mov     rbbi.fStyle,RBBS_GRIPPERALWAYS
                        invoke  SendMessage,hReBar,RB_INSERTBAND,-1,addr rbbi
                        invoke  SetWindowLong,hWnd,GWL_EXSTYLE,WS_EX_TOOLWINDOW
                        invoke  SetWindowLong,hWnd,GWL_STYLE,WS_POPUP
ender:                            
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

ToolboxWndProc  endp                
                            
end start                                            
